给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你可以尽可能地完成更多的交易(多次买卖一支股票)。
注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [7,1,5,3,6,4]
输出: 7
解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
示例 2:输入: [1,2,3,4,5]
输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:输入: [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
提示:
1 <= prices.length <= 3 * 10 ^ 4
0 <= prices[i] <= 10 ^ 4来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-ii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
public int maxProfit(int[] prices) { //动态规划 //时间复杂度 O(n) //空间复杂度 O(n) if(prices.length < 2){ return 0; } int length = prices.length; int dp[][] = new int[length][2]; //dp[i][0] 标识当天没有股票 //dp[i-1][0] 昨天也没有股票 //dp[i-1][1] + price[i] 昨天有股票今天卖了 //dp[i][1] //dp[i-1][0] 今天买股票 //dp[i-1][1] 今天不动 dp[0][0]=0; dp[0][1]=-prices[0]; for(int i = 1; i < length; i++){ dp[i][0] = Math.max(dp[i-1][0],dp[i-1][1]+prices[i]); dp[i][1] = Math.max(dp[i-1][0] - prices[i],dp[i-1][1]); } return dp[length-1][0]; }
public int maxProfit(int[] prices) { //动态规划 //时间复杂度 O(n) //空间复杂度 O(1) if(prices.length < 2){ return 0; } int length = prices.length; int dp[] = new int[2]; //将二维数组变更为一维数组 [i-1][0] [i-1][1] 替换为 [0][1] dp[0]=0; dp[1]=-prices[0]; int temp = 0; //使用额外的固定对象来替代循环中使用的临时变量 for(int i = 1; i < length; i++){ temp = Math.max(dp[0],dp[1]+prices[i]); dp[1] = Math.max(dp[0] - prices[i],dp[1]); dp[0] = temp; } return dp[0]; }
非动态规划的做法参考之前的文章:【力扣】122. 买卖股票的最佳时机 II